<?php
include(dirname(__FILE__).'/uniApi.php');

class unisender extends Module
{
	private $_html = '';
	public function __construct()
	{

		$this->name = 'unisender';
		$this->tab = 'advertising_marketing';
		$this->version = '0.1';
		$this->author = 'PrestaLab';
 
		parent::__construct();

		$this->displayName = $this->l('Рассылка unisender');
		$this->description = $this->l('Рассылка unisender');
	}

	public function getContent()
	{
		$this->_postProcess();
		$this->_displayForm();
		return $this->_html;
	}

	private function _displayForm()
	{
		$unisender_apikey=Tools::getValue('unisender_apikey', Configuration::get('unisender_apikey'));

		$this->_html .='
		<fieldset style="width: 300px;float:right;margin-left:15px;">
			<legend><img src="../img/admin/manufacturers.gif" /> ' . $this->l('Информация') . '</legend>
			<div id="dev_div">
				<span><b>' . $this->l('Версия') . ':</b> ' . $this->version . '</span><br>
				<span><b>' . $this->l('Лицензия') . ':</b> <a class="link" href="http://www.opensource.org/licenses/osl-3.0.php" target="_blank">OSL 3.0</a></span><br>
				<span><b>' . $this->l('Разработчик') . ':</b> <a class="link" href="mailto:admin@prestalab.ru" target="_blank">ORS</a><br>
		                <span><b>' . $this->l('Описание') . ':</b> <a class="link" href="http://prestalab.ru/" target="_blank">PrestaLab.ru</a><br>
				<p style="text-align:center"><a href="http://prestalab.ru/"><img src="http://prestalab.ru/upload/banner.png" alt="Модули и шаблоны для PrestaShop" /></a></p>
			</div>
		</fieldset>
		<form action="'.$_SERVER['REQUEST_URI'].'" method="post">
			<fieldset>
				<legend>'.$this->l('Ваш аккаунт в UniSender').'</legend>
					<label for="unisender_apikey">'.$this->l('API-ключ').'</label>
					<div class="margin-form">
						<input type="text" name="unisender_apikey" value="'.$unisender_apikey.'" />
						<p class="clear">'.$this->l('API-ключ').'</p>
					</div>
					<p class="center">
						<input class="button" type="submit" name="submitunisenderapi" value="'.$this->l('Сохранить').'"/>
					</p>
				</fieldset>
			</form>
		';

		if($unisender_apikey){
			$this->_html .='
			<form action="'.$_SERVER['REQUEST_URI'].'" method="post">
				<fieldset>
					<legend>'.$this->l('Список рассылки').'</legend>
						<label for="unisender_list">'.$this->l('Список рассылки').'</label>
						<div class="margin-form">
							<select name="unisender_list">';

			$uniapi= new uniApi($unisender_apikey);
			$server_lists=$uniapi->getLists();
			foreach ($server_lists as $server_list)
				$this->_html .='<option value="'.$server_list->id.'"'.($server_list->id==Tools::getValue('unisender_list', Configuration::get('unisender_list'))?' selected="selected"':'').'>'.$server_list->title.'</option>';
			
			$this->_html .='</select>
							<p class="clear">'.$this->l('Выберите список рассылки').'</p>
						</div>
						<label for="unisender_newsletter">'.$this->l('Выгружать всех').'</label>
						<div class="margin-form">
							<input type="checkbox" name="unisender_newsletter"'.(Tools::getValue('unisender_newsletter', Configuration::get('unisender_newsletter'))?' checked="checked"':'').' value="1" />
							<p class="clear">'.$this->l('Иначе выгружаются только подписчики.').'</p>
						</div>
						<p class="center">
							<input class="button" type="submit" name="submitunisendergen" value="'.$this->l('Отправить').'"/>
						</p>
					</fieldset>
				</form>
			';
		}
	}

	private function _postProcess()
	{
		if(Tools::isSubmit('submitunisenderapi'))
		{
			Configuration::updateValue('unisender_apikey', Tools::getValue('unisender_apikey'));
			$this->_html .= $this->displayConfirmation($this->l('Настройки обновлены.'));
		}elseif(Tools::isSubmit('submitunisendergen'))
		{
			$unisender_list=Tools::getValue('unisender_list');
			$unisender_newsletter=Tools::getValue('unisender_newsletter');
			Configuration::updateValue('unisender_list', $unisender_list);
			Configuration::updateValue('unisender_newsletter', $unisender_newsletter);

			$newsletters=self::getNewsletteremails(!$unisender_newsletter);
			$uniapi= new uniApi(Configuration::get('unisender_apikey'));
			$result=$uniapi->importContacts($newsletters, $unisender_list);
			$this->_html .= $this->displayConfirmation($this->l('Добавлено: ').$result['inserted'].$this->l('. Обновлено: ').$result['updated'].$this->l('. Требуют активации: ').$result['new_emails']);
		}
	}

	private static function getNewsletteremails($is_newsletter=true)
	{
		return Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS('
		SELECT c.`id_customer`, c.`email`, c.`firstname`, c.`lastname`, c.`newsletter`, c.`ip_registration_newsletter`, c.`newsletter_date_add`, a.`phone_mobile`
		FROM `'._DB_PREFIX_.'customer` c
		LEFT JOIN `'._DB_PREFIX_.'address` a ON (c.`id_customer` = a.`id_customer` AND a.`deleted` = 0 AND a.`active` = 1)
		WHERE '.($is_newsletter?'c.`newsletter` = 1 AND ':'').'c.`active` = 1
		GROUP BY c.`id_customer`');
	}
}